<mat-horizontal-stepper #stepper (selectionChange)="onStepChange($event)">
  <mat-step>
    <form [formGroup]="salesOrderFormGroup" #soForm="ngForm">
      <ng-template matStepLabel>{{ pageType === 'salesReturn' ?  'Sales Return Order' : 'Sales Order'}}</ng-template>
      <mat-form-field *ngIf="pageType === 'salesReturn'">
        <mat-label>Sales Orders</mat-label>
        <mat-select name="draftedOrder" formControlName="draftedOrder">
            <mat-option *ngFor="let salesOrder of closedSalesOrders" [value]="salesOrder.salesOrder"
            (click)="updateDraftedOrder(salesOrder)">
            {{salesOrder?.salesOrder}}
          </mat-option>
        </mat-select>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Customer</mat-label>
        <i class="fa fa-caret-down" aria-hidden="true"></i>
        <input type="text" placeholder="Customer" matInput [formControl]="customer" formControlName="customer"
          [matAutocomplete]="auto1">
        <mat-autocomplete #auto1="matAutocomplete">
          <mat-option *ngFor="let customer of filteredCustomers | async"
            (click)="updateSelect('salesOrderFormGroup', 'customer', customer.bpCode+ '-' +customer.name, customer.currency, customer)" [value]="customer.bpCode">
            {{customer.bpCode}} - {{customer.name}}
          </mat-option>
        </mat-autocomplete>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Warehouse</mat-label>
        <mat-select name="warehouse" formControlName="warehouse">
          <mat-option *ngFor="let warehouse of wareHouses" [value]="warehouse.code" (click)="getItemDetails(warehouse.code)">
            {{warehouse.code}} - {{warehouse.description}}
          </mat-option>
        </mat-select>
      </mat-form-field>
      <mat-form-field *ngIf="pageType === 'accountReceivable'">
        <mat-label>Drafted Sales Orders</mat-label>
        <mat-select name="draftedOrder" formControlName="draftedOrder">
          <mat-option (click)="updateDraftedOrder('')">Select</mat-option>
            <mat-option *ngFor="let draftedOrder of draftedOrders" [value]="draftedOrder.salesOrder"
            (click)="updateDraftedOrder(draftedOrder)">
            {{draftedOrder?.salesOrder}}
          </mat-option>
        </mat-select>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Currency</mat-label>
        <i class="fa fa-caret-down" aria-hidden="true"></i>
        <input type="text" placeholder="Currency" matInput [formControl]="currency" formControlName="currency"
          [matAutocomplete]="auto">
        <mat-autocomplete #auto="matAutocomplete">
          <mat-option *ngFor="let currency of filteredCurrencies | async"
            (click)="updateSelect('salesOrderFormGroup', 'currency', currency, null)" [value]="currency">
            {{currency}}
          </mat-option>
        </mat-autocomplete>
      </mat-form-field>
      <mat-form-field *ngIf="pageType === 'accountReceivable'">
        <mat-label>Terms of Deliveries</mat-label>
        <mat-select name="paymentTerm" formControlName="paymentTerm">
          <mat-option *ngFor="let paymentTerm of paymentTerms" [value]="paymentTerm">
            {{paymentTerm}}
          </mat-option>
        </mat-select>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Terms of Payment</mat-label>
        <mat-select name="paymentTerm2" formControlName="paymentTerm2">
          <mat-option *ngFor="let paymentTerm2 of paymentTerms2" [value]="paymentTerm2">
            {{paymentTerm2}}
          </mat-option>
        </mat-select>
      </mat-form-field>
      <mat-form-field *ngIf="pageType === 'accountReceivable'">
        <mat-label>Estimated Delivery Date</mat-label>
        <input matInput readonly [matDatepicker]="datepicker" formControlName="estimatedDeliveryDate" />
        <mat-datepicker-toggle matSuffix [for]="datepicker"></mat-datepicker-toggle>
        <mat-datepicker #datepicker></mat-datepicker>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Sales Order Date</mat-label>
        <input matInput readonly [matDatepicker]="creationDate" formControlName="creationDate" />
        <mat-datepicker-toggle matSuffix [for]="creationDate"></mat-datepicker-toggle>
        <mat-datepicker #creationDate></mat-datepicker>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Customer Order Reference</mat-label>
        <input type="text" matInput placeholder="Customer Order Reference" maxlength="150" formControlName="customerOrderReference">
      </mat-form-field>
      <mat-form-field>
        <mat-label>Sales Representative</mat-label>
        <mat-select name="salesRep" formControlName="salesRep">
          <mat-option *ngFor="let salesRep of salesReps" [value]="salesRep.key">
            {{salesRep.key}}-{{salesRep.value}}
          </mat-option>
        </mat-select>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Comments</mat-label>
        <textarea matInput placeholder="Comments" maxlength="150" rows="1" formControlName="notes"></textarea>
      </mat-form-field>
      <section class="so-list">
        <ul role="list">
          <li *ngFor="let item of itemsArr.controls; let i = index" [formGroup]="item">
            <span class="s-no">{{i+1}}</span>
            <mat-form-field *ngIf="pageType === 'accountReceivable'">
              <mat-label>Item Code</mat-label>
              <i class="fa fa-caret-down" aria-hidden="true"></i>
              <input type="text"
               placeholder="Item Code"
               matInput
               formControlName="tableItemCode"
               [matAutocomplete]="auto2">
                <mat-autocomplete #auto2="matAutocomplete" [displayWith]="displayItemId">
                  <mat-option *ngFor="let item of observers[i] | async" [value]="item.item.itemCode" (click)="updateItemDetails($event, i, item)">
                      {{item.item.itemCode}} - {{item.item.description}}
                  </mat-option>
                </mat-autocomplete>
            </mat-form-field>
            <mat-form-field *ngIf="pageType === 'salesReturn'">
              <mat-label>Item Code</mat-label>
              <input type="text"
               placeholder="Item Code"
               matInput
               formControlName="tableItemCode">
            </mat-form-field>
            <mat-form-field>
              <mat-label>Item Description</mat-label>
              <input matInput placeholder="Item Description" formControlName="itemDescription" required disabled>
            </mat-form-field>
            <mat-form-field>
              <mat-label>Available Quantity</mat-label>
              <input matInput placeholder="Available Quantity" formControlName="availableQuantity" required disabled>
            </mat-form-field>
            <mat-form-field>
              <mat-label>Quantity</mat-label>
              <input type="number" matInput placeholder="Quantity" (keyup)="updateAmount(i)" formControlName="quantity"
                required autocomplete="off">
            </mat-form-field>

            <mat-form-field>
              <mat-label>Unit</mat-label>
              <input type="text" matInput placeholder="unit" formControlName="unit" required disabled>
            </mat-form-field>
            <mat-form-field>
              <mat-label>Price</mat-label>
              <input type="number" matInput (keyup)="updateAmount(i)" (blur)="checkPrice(i)" placeholder="Price" formControlName="price"
                required>
            </mat-form-field>
            <mat-form-field>
              <mat-label>Discount %</mat-label>
              <input type="number" matInput (keyup)="updateAmount(i)" placeholder="Discount Percentage"
                formControlName="discountPercentage" required>
            </mat-form-field>
            <mat-form-field>
              <mat-label>Sub Total</mat-label>
              <input matInput placeholder="Sub Total" formControlName="subTotal" required disabled>
            </mat-form-field>
            <mat-form-field>
              <mat-label>VAT Code</mat-label>
              <mat-select name="vatCode" formControlName="vatCode">
                <mat-option *ngFor="let vat of vatCodes" [value]="vat.vatCode" (click)="updateVat(i, vat.vatPercentage)">
                  {{vat.vatCode}} - {{vat.vatDescription}}
                </mat-option>
              </mat-select>
            </mat-form-field>
            <mat-form-field>
              <mat-label>VAT %</mat-label>
              <input matInput placeholder="VAT Percentage" (keyup)="updateAmount(i)" formControlName="vatPercentage" required>
            </mat-form-field>
            <mat-form-field>
              <mat-label>Total Price</mat-label>
              <input matInput placeholder="Total Price" formControlName="totalprice" required disabled>
            </mat-form-field>
            <div class="button-item">
              <button mat-mini-fab class="add-remove-item remove" (click)="deleteDialog(i, item)">-</button>
            </div>
          </li>
        </ul>
      </section>
      <div *ngIf="pageType !== 'salesReturn'" class="button-item-add">
        <span><button mat-mini-fab class="add-remove-item add" (click)="addItem()">+</button></span> <span
          class="text-btn">Add Items</span>
      </div>
      <section *ngIf="itemsArr.controls.length > 0" class="summary-container">
        <h5>Summary</h5>
        <mat-list>
          <mat-list-item>
            <div class="summary-item">
              <span class="key">Total Amount: </span>
              <span class="value">{{poSummary.totalAmount | number : '1.0-2'}}</span>
            </div>
            <div class="summary-item">
              <span class="key">Discount Amount: </span>
              <span class="value">{{poSummary.discountAmount | number : '1.0-2'}}</span>
            </div>
            <div class="summary-item">
              <span class="key">Total Excl. VAT: </span>
              <span class="value">{{poSummary.subTotal | number : '1.0-2'}}</span>
            </div>
            <div class="summary-item">
              <span class="key">VAT Amount: </span>
              <span class="value">{{poSummary.vatAmount | number : '1.0-2'}}</span>
            </div>
            <div class="summary-item">
              <span class="key">Total Incl. VAT: </span>
              <span class="value">{{poSummary.amount | number : '1.0-2'}}</span>
            </div>
            <div class="summary-item" *ngIf="salesOrderFormGroup.controls['currency'].value !== 'SAR-Saudi riyal' && salesOrderFormGroup.controls['currency'].value !== ''">
              <span class="key">Total Excl. VAT in SAR: </span>
              <span class="value">{{poSummary.subTotalInSAR | number : '1.0-2'}}</span>
            </div>
            <div class="summary-item" *ngIf="salesOrderFormGroup.controls['currency'].value !== 'SAR-Saudi riyal' && salesOrderFormGroup.controls['currency'].value !== ''">
              <span class="key">Total Incl. VAT in SAR: </span>
              <span class="value">{{poSummary.amountInSAR | number : '1.0-2'}}</span>
            </div>
          </mat-list-item>
        </mat-list>
      </section>
      <div class="po-btn">
        <button class="save-btn" mat-button [disabled]="!salesOrderFormGroup.valid"
          (click)="onSubmitSo('save')">Save</button>
        <button mat-button [disabled]="!salesOrderFormGroup.valid" (click)="onSubmitSo('submit')">Submit</button>
      </div>
    </form>
  </mat-step>
  <mat-step>
    <form [formGroup]="materialShpAndDelFormGroup" #msForm="ngForm">
      <ng-template matStepLabel>{{ pageType === 'salesReturn' ?  'Materials Return' : 'Material Shipment/ Delivery'}}</ng-template>
          <mat-form-field *ngIf="pageType === 'accountReceivable'">
            <mat-label>Sales Orders</mat-label>
            <mat-select name="salesOrder" formControlName="soNumber">
              <mat-option *ngFor="let salesOrder of salesOrderOptions" [value]="salesOrder.salesOrder"
                (click)="updateSODetails(salesOrder)">
                {{salesOrder?.salesOrder}}
              </mat-option>
            </mat-select>
          </mat-form-field>
          <mat-form-field *ngIf="pageType === 'salesReturn'">
            <mat-label>Sales Return Orders</mat-label>
            <mat-select name="salesOrder" formControlName="soNumber">
              <mat-option *ngFor="let salesOrder of salesOrderOptions" [value]="salesOrder.salesOrder"
                (click)="updateSODetails(salesOrder)">
                {{salesOrder?.salesOrder}}
              </mat-option>
            </mat-select>
          </mat-form-field>
          <mat-form-field>
            <mat-label>Customer</mat-label>
            <input type="text" matInput placeholder="Customer" formControlName="customer" required [attr.disabled]='true'>
          </mat-form-field>
          <mat-form-field>
            <mat-label>Warehouse</mat-label>
            <input type="text" matInput placeholder="Warehouse" formControlName="warehouse" required [attr.disabled]='true'>
          </mat-form-field>
          <mat-form-field>
            <mat-label>Currency</mat-label>
            <input type="text" matInput placeholder="Currency" formControlName="currency" required [attr.disabled]='true'>
          </mat-form-field>
          <mat-form-field>
              <mat-label>{{pageType === 'accountReceivable' ? 'Shipment Date' : 'Shipment/Return Date'}}</mat-label>
              <input matInput readonly [matDatepicker]="shipmentDate" formControlName="shipmentDate">
              <mat-datepicker-toggle matSuffix [for]="shipmentDate"></mat-datepicker-toggle>
              <mat-datepicker #shipmentDate></mat-datepicker>
            </mat-form-field>
          <div class="mat-elevation-z8 ms-item" *ngIf='ELEMENT_DATA && ELEMENT_DATA.length > 0'>
            <table mat-table matSort [dataSource]="dataSource">
              <!-- Checkbox Column -->
              <ng-container matColumnDef="select">
                <th mat-header-cell *matHeaderCellDef>
                  <mat-checkbox (change)="$event ? masterToggle() : null"
                    [checked]="selection.hasValue() && isAllSelected()"
                    [indeterminate]="selection.hasValue() && !isAllSelected()" [aria-label]="checkboxLabel()">
                  </mat-checkbox>
                </th>
                <td mat-cell *matCellDef="let row">
                  <mat-checkbox (click)="$event.stopPropagation()" (change)="updateAmountMS($event, row)"
                    [checked]="selection.isSelected(row)" [aria-label]="checkboxLabel(row)">
                  </mat-checkbox>
                </td>
              </ng-container>
              <ng-container matColumnDef="S no">
                <th mat-header-cell *matHeaderCellDef> S No </th>
                <td class="link" mat-cell *matCellDef="let element; let i = index;"> {{i + 1}}</td>
              </ng-container>
              <!-- code Column -->
              <ng-container matColumnDef="Item Code">

                <th mat-header-cell *matHeaderCellDef mat-sort-header> Item Code </th>
                <td class="link" mat-cell *matCellDef="let element"> {{element.itemCode}} </td>
              </ng-container>

              <!-- name Column -->
              <ng-container matColumnDef="Description">
                <th mat-header-cell *matHeaderCellDef> Item Description </th>
                <td mat-cell *matCellDef="let element"> {{element.itemDescription}} </td>
              </ng-container>

              <ng-container matColumnDef="Quantity">
                <th mat-header-cell *matHeaderCellDef> Quantity </th>

                <td mat-cell *matCellDef="let element; let i = index; let row"> {{element.remainingQuantity}} <span class="update-qty"
                    *ngIf="element.remainingQuantity !== '0' && selection.isSelected(row)"
                    (click)="updateQty(element, i)">change</span></td>
              </ng-container>

              <ng-container matColumnDef="Unit">
                <th mat-header-cell *matHeaderCellDef> Unit </th>
                <td mat-cell *matCellDef="let element"> {{element.unit}} </td>
              </ng-container>
              <tr mat-header-row *matHeaderRowDef="displayedColumns"></tr>
              <tr mat-row *matRowDef="let row; columns: displayedColumns;"></tr>
            </table>

            <div class="asset-list" *ngIf="fixedAssetArr.controls.length > 0">
              <mat-list role="list">
                <mat-list-item *ngFor="let item of fixedAssetArr.controls; let i = index" [formGroup]="item">
                  <mat-form-field>
                    <mat-label>Item Code</mat-label>
                    <input matInput placeholder="Item Code" formControlName="itemCode" required disabled>
                  </mat-form-field>
                  <mat-form-field>
                    <mat-label>Fixed Asset Code</mat-label>
                    <mat-select name="assetCode" formControlName="assetCode">
                      <mat-option *ngFor="let asset of assetCodes" [value]="asset.assetCode">
                        {{asset.assetCode}} - {{asset.assetName}}
                      </mat-option>
                    </mat-select>
                  </mat-form-field>
                </mat-list-item>
              </mat-list>
            </div>
          </div>
      <div class="button-container">
        <button class="save-btn" mat-button matStepperPrevious>Back</button>
        <button (click)="submitMSForm()"
          [disabled]="!materialShpAndDelFormGroup.valid || selection.selected.length === 0" mat-button>Submit</button>
      </div>
    </form>
  </mat-step>
  <mat-step>
    <form [formGroup]="materialShpAndDelFormGroupTwo" #msFormTwo="ngForm">
      <ng-template matStepLabel>{{ pageType === 'salesReturn' ?  'Credit Note and Print' : 'Invoice Generate & Print'}}</ng-template>
      <mat-form-field>
        <mat-label>{{ pageType === 'salesReturn' ?  'Material Return code' : 'Select MS Code'}}</mat-label>
        <mat-select name="mrCode" formControlName="referenceOrder">
          <mat-option *ngFor="let msCode of msCodes" [value]="msCode.code" (click)="updateInvoiceDetails(msCode)">
            {{msCode.code}}
          </mat-option>
        </mat-select>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Invoice Amount</mat-label>
        <input type="number" matInput placeholder="Invoice Amount" formControlName="invoiceAmount" required>
      </mat-form-field>
      <mat-form-field>
        <mat-label>VAT Amount</mat-label>
        <input type="number" matInput placeholder="VAT Amount" formControlName="vatAmount" required>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Invoice Date</mat-label>
        <input matInput readonly [matDatepicker]="picker" formControlName="invoiceDate">
        <mat-datepicker-toggle matSuffix [for]="picker"></mat-datepicker-toggle>
        <mat-datepicker #picker></mat-datepicker>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Currency</mat-label>
        <mat-select name="currency" formControlName="invoiceCurrency">
          <mat-option *ngFor="let currency of currencies" [value]="currency">
            {{currency}}
          </mat-option>
        </mat-select>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Comments</mat-label>
        <textarea matInput placeholder="Comments" rows="1" formControlName="notes"></textarea>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Delivery Note</mat-label>
        <input type="text" matInput placeholder="Delivery Note" formControlName="deliveryNote" required>
      </mat-form-field>
      <div class="button-container">
        <button class="save-btn" mat-button matStepperPrevious>Back</button>
        <button mat-button [disabled]="!materialShpAndDelFormGroupTwo.valid" (click)="submitMSInvoice()">Submit</button>
      </div>
    </form>
  </mat-step>
  <mat-step *ngIf="pageType !== 'salesReturn'">
    <form [formGroup]="collectionsFormGroup" #collectionForm="ngForm">
      <ng-template matStepLabel>Collection</ng-template>
      <mat-form-field>
        <mat-label>Customer</mat-label>
        <mat-select name="customer" formControlName="customer">
          <mat-option *ngFor="let customer of customers" [value]="customer.bpCode" (click)="updateSo(customer)">
            {{customer.bpCode}} - {{customer.name}}
          </mat-option>
        </mat-select>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Bank Name</mat-label>
        <mat-select name="bankName" formControlName="bankName">
          <mat-option *ngFor="let bank of availableBanks" [value]="bank">
            {{bank}}
          </mat-option>
        </mat-select>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Transaction Entry Date</mat-label>
        <input matInput readonly [matDatepicker]="picker1" formControlName="transactionEntryDate">
        <mat-datepicker-toggle matSuffix [for]="picker1"></mat-datepicker-toggle>
        <mat-datepicker #picker1></mat-datepicker>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Document Date</mat-label>
        <input matInput readonly [matDatepicker]="picker2" formControlName="documentDate">
        <mat-datepicker-toggle matSuffix [for]="picker2"></mat-datepicker-toggle>
        <mat-datepicker #picker2></mat-datepicker>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Type Of Transaction</mat-label>
        <mat-select name="typeOfTransaction" formControlName="typeOfTransaction">
          <mat-option *ngFor="let transaction of typesOfTransactions" [value]="transaction" (click)="checkVat(transaction)">
            {{transaction}}
          </mat-option>
        </mat-select>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Select Invoice Number</mat-label>
        <mat-select name="invoiceBookings" formControlName="invoiceBookings" multiple>
          <mat-option *ngFor="let invoiceBooking of invoiceBookings" [value]="invoiceBooking.invoiceNumber"
            (onSelectionChange)="updateItemsPayAmount($event, invoiceBooking)">
            {{invoiceBooking.invoiceNumber}}
          </mat-option>
        </mat-select>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Currency</mat-label>
        <mat-select name="currency" formControlName="currency">
          <mat-option *ngFor="let currency of currencies" [value]="currency">
            {{currency}}
          </mat-option>
        </mat-select>
      </mat-form-field>
      <div class='paymentList ms-item'>
        <mat-list role="list">
          <mat-list-item *ngFor="let item of amountArr.controls; let i = index" [formGroup]="item">

            <mat-form-field>
              <mat-label>Sales Order Code</mat-label>
              <input type="text" matInput placeholder="Material Recieved Code" formControlName="selectedMSNumber"
                required disabled>
            </mat-form-field>
            <mat-form-field>
              <mat-label>Material Shipped Code</mat-label>
              <input type="text" matInput placeholder="Material Shipped Code" formControlName="materialShipped" required disabled>
            </mat-form-field>
            <mat-form-field>
              <mat-label>Amount</mat-label>
              <input type="number" matInput placeholder="Amount" (keyup)="updateTotalPayAmount(i)"
                formControlName="totalprice" required disabled>
            </mat-form-field>
          </mat-list-item>
        </mat-list>
      </div>
      <mat-form-field>
        <mat-label>VAT Code</mat-label>
        <mat-select name="vatCode" formControlName="vatCode">
          <mat-option *ngFor="let vat of vatCodes" [value]="vat.vatCode" (click)="updateVatPayment(vat.vatPercentage)">
            {{vat.vatCode}} - {{vat.vatDescription}}
          </mat-option>
        </mat-select>
      </mat-form-field>
      <mat-form-field>
        <mat-label>VAT %</mat-label>
        <input matInput placeholder="VAT Percentage " (keyup)="updateAmountPayment($event)" formControlName="vatPercentage" >
      </mat-form-field>
      <mat-form-field>
        <mat-label>Gross Amount</mat-label>
        <input matInput placeholder="Gross Amount " (keyup)="updateAmountPaymentGross($event)" formControlName="grossamt" required>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Net Amount</mat-label>
        <input matInput type="number" placeholder="Net Amount" formControlName="grandtotalprice"
          required>
      </mat-form-field>
      <mat-form-field>
        <mat-label>Comments</mat-label>
        <textarea matInput placeholder="Comments" rows="1" formControlName="notes"></textarea>
      </mat-form-field>
      <div class="button-container">
        <button class="save-btn" mat-button matStepperPrevious>Back</button>
        <button mat-button [disabled]="!collectionsFormGroup.valid" (click)="submitPayment()">Submit
          Collections</button>
      </div>
    </form>
  </mat-step>
</mat-horizontal-stepper>